# coding: utf-8

"""
    Vectara REST API v2

    Vectara provides an end-to-end platform for creating GenAI products using  a simple to use API.  You can [sign up for an account](https://console.vectara.com/signup) and  then view several [API Recipes](https://docs.vectara.com/docs/api-recipes) with example queries  and parameter values.  The Vectara API Playground lets you experiment with REST endpoints from  your browser. Select an endpoint to view its definition, including the  required or optional headers, body, responses, and sample commands. On the  right side of each endpoint page, like [Get Corpus](/docs/rest-api/get-corpus), you manually  enter your API Key or OAuth Bearer Token, `customer_id`, and then any  required body parameters like the `corpusID` before sending the API  request.  :::note  Vectara supports two primary methods of authentication: API keys and OAuth  2.0, which are applicable to all endpoints. Query API Keys are used for  read-only querying operations, while Index API Keys provide read and write  access. The OAuth 2.0 operations authenticate with a Bearer Token via the  OAuth 2.0 client credentials grant. Review the [**OAuth 2.0 section**](https://docs.vectara.com/docs/learn/authentication/oauth-2) about  how to generate the token. 

    The version of the OpenAPI document: 2.0.0
    Contact: feedback@vectara.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from vectara_client.models.individual_search_result import IndividualSearchResult
from vectara_client.models.language import Language
from typing import Optional, Set
from typing_extensions import Self

class ChatFullResponse(BaseModel):
    """
    Full response to a chat question when the result is not streamed.
    """ # noqa: E501
    chat_id: Optional[StrictStr] = Field(default=None, description="If the chat response was stored, the ID of the chat.")
    turn_id: Optional[StrictStr] = Field(default=None, description="If the chat response was stored, the ID of the turn.")
    answer: Optional[StrictStr] = Field(default=None, description="The message from the chat model for the chat message.")
    response_language: Optional[Language] = None
    search_results: Optional[List[IndividualSearchResult]] = Field(default=None, description="The ranked search results that the chat model used.")
    factual_consistency_score: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The probability that the summary is factually consistent with the results. ")
    __properties: ClassVar[List[str]] = ["chat_id", "turn_id", "answer", "response_language", "search_results", "factual_consistency_score"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChatFullResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in search_results (list)
        _items = []
        if self.search_results:
            for _item in self.search_results:
                if _item:
                    _items.append(_item.to_dict())
            _dict['search_results'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChatFullResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chat_id": obj.get("chat_id"),
            "turn_id": obj.get("turn_id"),
            "answer": obj.get("answer"),
            "response_language": obj.get("response_language"),
            "search_results": [IndividualSearchResult.from_dict(_item) for _item in obj["search_results"]] if obj.get("search_results") is not None else None,
            "factual_consistency_score": obj.get("factual_consistency_score")
        })
        return _obj


